	local modName = g_currentModName;
	local modDir = g_currentModDirectory;
	ZZZAnywhereunload = {}
	ZZZAnywhereunload_mt = Class(ZZZAnywhereunload, Object)
	ZZZAnywhereunload.sendNumBits = 6

	function onCreate(self,id)
	print("created ZZZAnywhereunload, id: ", tostring(id));
	local object = ZZZAnywhereunload:new(g_server ~= nil, g_client ~= nil)
	if object:load(id) then
		g_currentMission:addOnCreateLoadedObject(object)
		object:register(true)
	else
		object:delete()
	end
	end


	function ZZZAnywhereunload:new(isServer, isClient, customMt)
		local mt = customMt
		if mt == nil then
			mt = ZZZAnywhereunload_mt
		end
		local self = Object:new(isServer, isClient, mt)
		self.ZZZAnywhereunloadDirtyFlag = self:getNextDirtyFlag();
		self.className = modName..".ZZZAnywhereunload";
		return self
	end
    
    
    function ZZZAnywhereunload:load(nodeId, fillType)
    
        self.nodeId = nodeId;
        if g_currentMission:getIsServer() then
            self.triggerId = Utils.indexToObject(nodeId, getUserAttribute(nodeId, "triggerIndex"));
            if self.triggerId == nil then
                self.triggerId = nodeId;
            end
            addTrigger(self.triggerId, "triggerCallback", self);
        end
    
        self.isEnabled = true;
    
        self.isSiloTrigger = Utils.getNoNil(getUserAttribute(nodeId, "isSiloTrigger"), false);
		self.isSUGARBEET = Utils.getNoNil(getUserAttribute(nodeId, "isSUGARBEET"), false);	
        self.isPOTATO = Utils.getNoNil(getUserAttribute(nodeId, "isPOTATO"), false);	
			
        self.currentShovel = nil;
        return true;
		
			
    end;
    
    function ZZZAnywhereunload:delete()
        if self.triggerId ~= 0 then
            removeTrigger(self.triggerId);
        end
    end;
    
    function ZZZAnywhereunload:update(dt)
        if self.currentShovel ~= nil then
            -- get the shovel object again (maybe it was deleted in the meantime)
            local shovel = g_currentMission.nodeToVehicle[self.currentShovelNode];
            self.currentShovel = shovel;
            if shovel ~= nil then
                self:fillShovel(shovel, dt);
            end
        end
    end
    
    function ZZZAnywhereunload:fillShovel(shovel, dt)
        
		if self.isSUGARBEET then
			self.fillType = Fillable.FILLTYPE_RUEBENALTERNATIVE;
			self.ShovelfillType = Fillable.FILLTYPE_SUGARBEET;
		end;
		if self.isPOTATO then
			self.fillType = Fillable.FILLTYPE_POTATOALTERNATIVE;
			self.ShovelfillType = Fillable.FILLTYPE_POTATO;
		end;
		
		
		if self.isSiloTrigger then
		
				
		   local silo = g_currentMission:getSiloAmount(self.fillType); -- fuellstand von alternativ abfragen
            if silo > 0 then -- wenn alternativfuellstand groeßer null
                local delta = shovel:fillShovelFromTrigger(self, silo, self.ShovelfillType, dt); -- schaufel mit definiertem Fruchtyp fuellen
                if delta > 0 then -- wenn schaufel befuellt wird
                    g_currentMission:setSiloAmount(self.fillType, silo-delta); -- fuellstand von alternativ anpassen / aendern
                end
            end
			
        else
            local delta = shovel:fillShovelFromTrigger(self, math.huge, self.fillType, dt);
            if delta > 0 then
                local price = Fillable.fillTypeIndexToDesc[self.fillType].pricePerLiter;
                if price > 0 then
                   g_currentMission:addSharedMoney(-price*delta, "other");
               end
           end
       end
   end
   
   function ZZZAnywhereunload:triggerCallback(triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
       if self.isEnabled and (onEnter or onLeave) then
   
           local shovel = g_currentMission.nodeToVehicle[otherShapeId];
           if shovel ~= nil then
               if onLeave then
                   if self.currentShovel == shovel and self.currentShovelNode == otherShapeId then
                       self.currentShovel = nil;
                   end
               else
                   if shovel.allowFillFromShovelTrigger and shovel.fillShovelFromTrigger ~= nil and (shovel.shovelNodes == nil or shovel.shovelNodes[otherShapeId]) then
                       self.currentShovel = shovel;
                       self.currentShovelNode = otherShapeId;
                   end;
               end;
           end;
       end;
   end;